CmdUtils.CreateCommand({
  name: "amazon-jp-search",
  icon: "http://www.amazon.co.jp/favicon.ico",
  author: { name: "Taro Matsuzawa", email: "btm@mozilla.gr.jp"},
  license: "GPL",
  description: "Searches <a href=\"http://www.amazon.co.jp\">Amazon.co.jp</a> for books matching your words.",
  url: "http://www.amazon.co.jp/s/ref=nb_ss_gw?__mk_ja_JP=%83J%83%5E%83J%83i&url=search-alias%3Dstripbooks&field-keywords={QUERY}&x=0&y=0",
  takes: {"input": noun_arb_text},
  preview: function( pblock, input ) {
    if(!input.text || input.text.length < 1) {
      pblock.innerHTML = "Searches for books on Amazon.co.jp";
      return;
    }

    pblock.innerHTML = "Searching Amazon for books matching <b>" + input.summary + "</b>";
  },
  execute: function(input) {   
    var query = escape(this.convertUTF16toSJIS(input.text));
    var urlString = this.url.replace("{QUERY}", query);
    Utils.openUrlInBrowser(urlString);
    CmdUtils.setLastResult(urlString);
  },
  convertUTF16toSJIS: function(u_str) {
    var UConvID = '@mozilla.org/intl/scriptableunicodeconverter';
    var UConvIF  = Components.interfaces.nsIScriptableUnicodeConverter;
    var UConv = Components.classes[UConvID].getService(UConvIF);
    UConv.charset = 'SHIFT-JIS';
    return UConv.ConvertFromUnicode(u_str);
  }
});
